import java.applet.Applet;
import java.awt.*;

public class FractalHeart extends Applet {
  int[] xPoints = new int[3];
  int[] yPoints = new int[3];

  final Color centerColor = new Color(255, 220, 220);
  final Color leftColor = new Color(220, 0, 200);
  final Color rightColor = new Color(200, 0, 255);
  final Color borderColor = new Color(0, 0, 255);

  public int getWidth() // getWidth is defined for java 1.2, but not 1.1
  {
    return getSize().width;
  }

  public int getHeight() // same as getWidth.
  {
     return getSize().height;
  }


  public void run() {
    setBackground(centerColor);
  }
  void drawHeart(Graphics g, int x1, int y1, int x2, int y2, int x3, int y3, int depth, int which, int parent)  {
    if (depth > 10) {
      return;
    }
    xPoints[0] = x1;
    xPoints[1] = x2;
    xPoints[2] = x3;

    yPoints[0] = y1;
    yPoints[1] = y2;
    yPoints[2] = y3;
    final int x4 = x1;
    final int y4 = y1 - (y3 - y1) / 2;
    g.fillPolygon(xPoints, yPoints, 3);
    g.fillArc(x4, y4, (x2 - x1) / 2, (y1 - y4) * 2, 0, 180);
    g.fillArc(x4+(x2-x1)/2, y4, (x2 - x1) / 2, (y1 - y4) * 2, 0, 180);
    g.setColor(borderColor);
    //g.drawLine(x1, y1, x3, y3);
    //g.drawLine(x3, y3, x2, y2);
    if (which == parent)
    {
      g.drawArc(x4, y4, (x2 - x1) / 2, (y1 - y4) * 2, 0, 180);
      g.drawArc(x4 + (x2 - x1) / 2, y4, (x2 - x1) / 2, (y1 - y4) * 2, 0, 180);
    }

    /*
    \    /
     \--/
      \/
      */
    g.setColor(centerColor);
    drawHeart(g, (x1 + x3) / 2, (y1 + y3) / 2, (x2 + x3) / 2, (y2 + y3) / 2, x3, y3, depth+1, 0, which);
    /*
    \--/ /
     \/ /
      \/
    */
    g.setColor(leftColor);
    drawHeart(g, x1, y1, (x2 + x1) / 2, (y2 + y1) / 2, (x1 + x3) / 2, (y1 + y3) / 2, depth + 1, 1, which);
    /*
    \ \--/
     \ \/
      \/
    */

    g.setColor(rightColor);
    drawHeart(g, (x2 + x1) / 2, (y2 + y1) / 2, x2, y2, (x2 + x3) / 2, (y2 + y3) / 2, depth + 1, 2, which);
  }

  public void paint(Graphics g) {
    g.setColor(centerColor);
    g.fillRect(0, 0, getWidth(), getHeight());
    drawHeart(g, 0, getHeight()/3, getWidth(), getHeight() / 3, getWidth() / 2, getHeight(), 0, 0, 0);
  }
}

